(in-package :olm-recommender-demo)

(defun extend-user-map (user-map new-delegates new-triples new-antitriples)
  (let ((new-map (netfarm:update-object user-map)))
    (macrolet ((unionf (place value)
                 `(setf ,place (union ,place ,value :test #'equal))))
      (unionf (netfarm:user-map-delegates new-map)
              new-delegates)
      (unionf (netfarm:user-map-triples new-map)
              new-triples)
      (unionf (netfarm:user-map-antitriples new-map)
              new-antitriples))
    (netfarm:add-signature new-map *keys* *user*)
    (netfarm-scripts:run-script-machines new-map)
    new-map))

(clim:define-command (com-add-fact :command-table recommender-demo-app :name t)
    ((subject netfarm:object :prompt "Subject")
     (predicate string :prompt "Predicate")
     (target netfarm:object :prompt "Target"))
  (setf (user-map *recommender*)
        (extend-user-map (user-map *recommender*)
                         '()
                         (list (list subject predicate target))
                         '()))
  (netfarm-interactor:update-presentation clim:*application-frame*))

(clim:define-command (com-add-lie :command-table recommender-demo-app :name t)
    ((subject netfarm:object :prompt "Subject")
     (predicate string :prompt "Predicate")
     (target netfarm:object :prompt "Target"))
  (setf (user-map *recommender*)
        (extend-user-map (user-map *recommender*)
                         '()
                         '()
                         (list (list subject predicate target))))
  (netfarm-interactor:update-presentation clim:*application-frame*))

(clim:define-command (com-add-delegate :command-table recommender-demo-app :name t)
    ((delegate named-user-map :prompt "Delegate"))
  (setf (user-map *recommender*)
        (extend-user-map (user-map *recommender*)
                         (list delegate)
                         '()
                         '()))
  (netfarm-interactor:update-presentation clim:*application-frame*))

(clim:define-command (com-list-other-users :command-table recommender-demo-app
                                           :name t)
    ()
  (let ((sorted-maps (sort (loop with our-map = (user-map *recommender*)
                                 for map in *other-maps*
                                 collect (list map (correlation map our-map)))
                           #'>
                           :key #'second)))
    (dolist (map-info sorted-maps)
      (destructuring-bind (map correlation) map-info
        (clim:present map 'named-user-map :stream *query-io*)
        (format *query-io* " (correlation: ~$)~%" correlation)))))
